bl_info = {
    "name" : "Electro Addon",
    "author" : "CGBlender", 
    "description" : "Electro Add-on is a blender addon, that is an easy tool for creating procedural lightning on blender 3d, the addon has easy tools like lightning draw and more parameters that will make you able to create lightning easily on blender for your environment, or if you are trying to make a good animation that addon will help you for that.",
    "blender" : (3, 0, 0),
    "version" : (1, 0, 0),
    "location" : "",
    "waring" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "3D View" 
}


import bpy
import bpy.utils.previews

import os
import os


def string_to_int(value):
    if value.isdigit():
        return int(value)
    return 0

def string_to_icon(value):
    if value in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items.keys():
        return bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items[value].value
    return string_to_int(value)
    
def icon_to_string(value):
    for icon in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items:
        if icon.value == value:
            return icon.name
    return "NONE"
    
def enum_set_to_string(value):
    if type(value) == set:
        if len(value) > 0:
            return "[" + (", ").join(list(value)) + "]"
        return "[]"
    return value
    
def string_to_type(value, to_type, default):
    try:
        value = to_type(value)
    except:
        value = default
    return value

addon_keymaps = {}
_icons = None
electro_addon = {}


_item_map = dict()
def make_enum_item(_id, name, descr, preview_id, uid):
    lookup = str(_id)+"\0"+str(name)+"\0"+str(descr)+"\0"+str(preview_id)+"\0"+str(uid)
    if not lookup in _item_map:
        _item_map[lookup] = (_id, name, descr, preview_id, uid)
    return _item_map[lookup]
def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id
def sna_update_sna_elctro_8A609(self, context):
    sna_updated_prop = self.sna_elctro
    bpy.ops.wm.append(directory=os.path.join(os.path.dirname(__file__), 'assets', 'Lightning Line.blend') + r'\Object', filename=sna_updated_prop, link=False)
    for i_95C67 in range(len(bpy.context.view_layer.objects.selected)):
        if bpy.context.view_layer.objects.selected[i_95C67].select_get():
            bpy.context.view_layer.objects.active = bpy.context.view_layer.objects.selected[i_95C67]
        else:
            pass

def sna_elctro_enum_items(self, context):
    enum_items = [['e1', 'e1', '', load_preview_icon(os.path.join(os.path.dirname(__file__), 'assets', 'ooo1.png'))]]
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]
class SNA_PT_ELECTRO_958CA(bpy.types.Panel):
    bl_label = 'Electro'
    bl_idname = 'SNA_PT_ELECTRO_958CA'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'EL'
    bl_order = 0
    
    
    @classmethod
    def poll(cls, context):
        return not (False)
    
    def draw_header(self, context):
        layout = self.layout
        
    def draw(self, context):
        layout = self.layout
        layout.template_icon_view(bpy.context.scene, 'sna_elctro', show_labels=False, scale=5.0, scale_popup=5.0)
        col_50739 = layout.column(heading='', align=False)
        col_50739.alert = False
        col_50739.enabled = True
        col_50739.use_property_split = False
        col_50739.use_property_decorate = False
        col_50739.scale_x = 1.0
        col_50739.scale_y = 1.0
        col_50739.alignment = 'Expand'.upper()
        op = col_50739.operator('screen.animation_play', text='Play', icon_value=495, emboss=True, depress=False)
        col_50739.prop(bpy.context.view_layer.objects.active.modifiers['GeometryNodes'], '["Input_4"]', text='Edges Scale', icon_value=245, emboss=True)
        col_50739.prop(bpy.context.view_layer.objects.active.active_material.node_tree.nodes['Emission'].inputs[0], 'default_value', text='Color', icon_value=245, emboss=True)
        col_50739.prop(bpy.context.view_layer.objects.active.active_material.node_tree.nodes['Emission'].inputs[1], 'default_value', text='Emission Strength', icon_value=245, emboss=True)
        
class SNA_OT_Draw_D4536(bpy.types.Operator):
    bl_idname = "sna.draw_d4536"
    bl_label = "draw"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    
    
    @classmethod
    def poll(cls, context):
        return not False
    def execute(self, context):
        bpy.ops.object.mode_set('INVOKE_DEFAULT', mode='EDIT')
        return {"FINISHED"}
    
    def invoke(self, context, event):
        
        
        return self.execute(context)




def register():
    
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.types.Scene.sna_elctro = bpy.props.EnumProperty(name='elctro', description='', items=sna_elctro_enum_items, update=sna_update_sna_elctro_8A609)
    
    
    bpy.utils.register_class(SNA_PT_ELECTRO_958CA)
    bpy.utils.register_class(SNA_OT_Draw_D4536)

def unregister():
    
    global _icons
    bpy.utils.previews.remove(_icons)
    
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_elctro
    
    
    bpy.utils.unregister_class(SNA_PT_ELECTRO_958CA)
    bpy.utils.unregister_class(SNA_OT_Draw_D4536)

